
    var MP = {};

    MP.mp_editor = document.getElementById('mp_editor');
    function addLink(link){
		document.execCommand('CreateLink',"false",link);
	}
    function setHeadH5(){
    document.execCommand('formatBlock', false, '<h5>');
    getState();
    }

    function setHeadH3(){
    document.execCommand('formatBlock', false, '<h3>');
    getState();
    }
    function setHeadH1(){
    document.execCommand('formatBlock', false, '<h1>');
    getState();
    }

    function setBold(){
    document.execCommand("bold",false,null);
    getState();
    }

    function setItalic(){
    document.execCommand("italic",false,null);
    getState();
    }

    function setUnderline(){
    document.execCommand("underline",false,null);
    getState();
    }
    function setLeft(){
    document.execCommand("justifyLeft",false,null);
    getState();
    }
    function setRight(){
    document.execCommand("justifyRight",false,null);
    getState();
    }

    function setCenter(){
    document.execCommand("justifyCenter",false,null);
    getState();
    }

    function selectAll(){
    document.execCommand("selectAll")
    }

    function setColor(color){
     document.execCommand("ForeColor",false,color);
    }

   function undo() {
        document.execCommand('undo', false, null);
   }

    function redo() {
        document.execCommand('redo', false, null);
    }


    function getHtml(){
         return document.getElementById('mp_editor').innerHTML.replace(/(\n)/g,"");
    }

    function setHtml(content){
           document.getElementById('mp_editor').innerHTML = decodeURIComponent(content);
           str= decodeURIComponent(content);
    }

    function getText(){
           var message=$(MP.mp_editor).text().replace(/(\n)/g,"");
           window.android.toastMessage($.trim(message))
    }

    function setMax(max){
          maxLength = max;
    }

    function focus(){
          $(MP.mp_editor).focus();
          var range = window.getSelection();//创建range
                      range.selectAllChildren(MP.mp_editor);//range 选择obj下所有子内容
                      range.collapseToEnd();//光标移至最后


                       var items = [];
                          if (document.queryCommandState('bold')) {
                              items.push('bold');
                          }
                          if (document.queryCommandState('italic')) {
                              items.push('italic');
                          }
                          if (document.queryCommandState('underline')) {
                              items.push('underline');
                          }

                          if (document.queryCommandState('justifyCenter')) {
                              items.push('justifyCenter');
                          }
                          if (document.queryCommandState('justifyLeft')) {
                              items.push('justifyLeft');
                          }
                          if (document.queryCommandState('justifyRight')) {
                              items.push('justifyRight');
                          }
                          var formatBlock = document.queryCommandValue('formatBlock');
                          if (formatBlock.length > 0) {
                              items.push(formatBlock);
                          }

//                          if(items.indexOf("h1")<0 && items.indexOf("h5")<0 && items.indexOf("h3")<0)
//                          {
//                          var content =document.getElementById('mp_editor').innerHTML.length;
//                          if(content<=0)
//                              {
//                              items.push("h3");
//                              }
//                          }

                          window.location.href = "mp-state://" + encodeURI(items.join(','));
    }

    function hint(placeholder) {
        $(MP.mp_editor).attr("placeholder", placeholder);
    }

    var str = "";
    var maxLength=99999999;

    MP.callback = function() {
        if($(this).text().length <= maxLength ){
            str = this.innerHTML;
        }else if($(this).text().length > maxLength){
            this.innerHTML = str;
//            $(this).trigger("input");
            this.focus(); //解决ff不获取焦点无法定位问题
            var range = window.getSelection();//创建range
            range.selectAllChildren(this);//range 选择obj下所有子内容
            range.collapseToEnd();//光标移至最后
        }

      var content =document.getElementById('mp_editor').innerHTML.length;
      if(content<=0)
          {
         document.execCommand('formatBlock', false, '<h3>');
          }

        window.android.setAndroidHtml(getHtml());
    }
    var currentItem;

    MP.enabledEditingItems = function(e) {
            getState();
    }


    function getState(){
    var items = [];
        if (document.queryCommandState('bold')) {
            items.push('bold');
        }
        if (document.queryCommandState('italic')) {
            items.push('italic');
        }
        if (document.queryCommandState('underline')) {
            items.push('underline');
        }

        if (document.queryCommandState('justifyCenter')) {
            items.push('justifyCenter');
        }
        if (document.queryCommandState('justifyLeft')) {
            items.push('justifyLeft');
        }
        if (document.queryCommandState('justifyRight')) {
            items.push('justifyRight');
        }
        var formatBlock = document.queryCommandValue('formatBlock');
        if (formatBlock.length > 0) {
            items.push(formatBlock);
        }
        currentItem = items;
        window.location.href = "mp-state://" + encodeURI(items.join(','));
        }


    MP.mp_editor.addEventListener("input",MP.callback);


    MP.mp_editor.addEventListener("keyup", function(e) {
        var KEY_LEFT = 37, KEY_RIGHT = 39;
        if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
            MP.enabledEditingItems(e);
        }else if( e.which ==13)
        {
          integrationOnLineStyle();
        }
    });
    $(MP.mp_editor).on("click",MP.enabledEditingItems);
    $(window).on("touchend",MP.enabledEditingItems);
    $(document).on("selectionchange",MP.enabledEditingItems);


       function integrationOnLineStyle(){
            if(currentItem.indexOf("h1")>=0)
            {
                document.execCommand('formatBlock', false, '<h1>');
            }
            if(currentItem.indexOf("h3")>=0)
            {
                document.execCommand('formatBlock', false, '<h3>');
            }
            if(currentItem.indexOf("h5")>=0)
            {
                document.execCommand('formatBlock', false, '<h5>');
            }

             if(currentItem.indexOf("justifyCenter")>=0)
            {
                 document.execCommand("justifyCenter",false,null);
            }
            if(currentItem.indexOf("justifyLeft")>=0)
            {
            document.execCommand("justifyLeft",false,null);
            }
            if(currentItem.indexOf("justifyRight")>=0)
            {
             document.execCommand("justifyRight",false,null);
            }
       }


    window.onload = function(){
        $(MP.mp_editor).click();
        $(MP.mp_editor).focus();

    };

    $('[contenteditable]').each(function() {
		    // 干掉IE http之类地址自动加链接
		    try {
		        document.execCommand("AutoUrlDetect", false, false);
		    } catch (e) {}

		    $(this).on('paste', function(e) {
		        e.preventDefault();
//		        var text = '';
//		        if(window.clipboardData && clipboardData.setData) {
//		            // IE
//		            text = window.clipboardData.getData('text');
//		        } else {
//		            text = (e.originalEvent || e).clipboardData.getData('text/plain')|| (e.originalEvent || e).clipboardData.getData('text');
//		        }
//		        alert("1="+text);
                window.android.getPasteText();
                 });
		});
        //  android   getPasteText();

        //   js  setPasteText2InnerHtml( string );
       function setPasteText2InnerHtml( text ){
            text =decodeURIComponent(text);
            if (document.body.createTextRange) {
                if (document.selection) {
                    textRange = document.selection.createRange();
                } else if (window.getSelection) {
                    sel = window.getSelection();
                    var range = sel.getRangeAt(0);

                    // 创建临时元素，使得TextRange可以移动到正确的位置
                    var tempEl = document.createElement("span");
                    tempEl.innerHTML = "&#FEFF;";
                    range.deleteContents();
                    range.insertNode(tempEl);
                    textRange = document.body.createTextRange();
                    textRange.moveToElementText(tempEl);
                    tempEl.parentNode.removeChild(tempEl);
                }
                textRange.text = text;
                textRange.collapse(false);
                textRange.select();
            } else {
                // Chrome之类浏览器
                document.execCommand("insertText", false, text);
            }

       }




